.\"	$NetBSD: ec.4,v 1.12 2003/04/06 19:33:57 wiz Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)ec.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt EC 4 vax
.Os
.Sh NAME
.Nm ec
.Nd 3Com 10 Mb/s Ethernet interface
.Sh SYNOPSIS
.Cd "ec0 at uba0 csr 161000 vector ecrint eccollide ecxint flags 0"
.Sh DESCRIPTION
NOTE: This driver has not been ported from
.Bx 4.4
yet.
.Pp
The
.Nm ec
interface provides access to a 10 Mb/s Ethernet network through
a 3Com controller.
.Pp
The hardware has 32 kilobytes of dual-ported memory on the
.Tn UNIBUS .
This memory
is used for internal buffering by the board, and the interface code reads
the buffer contents directly through the
.Tn UNIBUS .
The address of this memory is given in the
.Ar flags
field
in the configuration file.
The first interface normally has its memory at UNIBUS address 0.
.Pp
Each of the host's network addresses
is specified at boot time with an
.Dv SIOCSIFADDR
.Xr ioctl 2 .
The
.Nm ec
interface employs the address resolution protocol described in
.Xr arp 4
to dynamically map between Internet and Ethernet addresses on the local
network.
.Pp
The interface normally tries to use a
.Dq trailer
encapsulation
to minimize copying data on input and output.
The use of trailers is negotiated with
.Tn ARP .
This negotiation may be disabled, on a per-interface basis,
by setting the
.Dv IFF_NOTRAILERS
flag with an
.Dv SIOCSIFFLAGS
.Xr ioctl 2 .
.Pp
The interface software implements an exponential backoff algorithm
when notified of a collision on the cable.  This algorithm uses
a 16-bit mask and the
.Tn VAX-11 Ns 's
interval timer in calculating a series
of random backoff values.  The algorithm is as follows:
.Bl -enum -offset indent
.It
Initialize the mask to be all 1's.
.It
If the mask is zero, 16 retries have been made and we give
up.
.It
Shift the mask left one bit and formulate a backoff by
masking the interval timer with the smaller of the complement of this mask
and a 5-bit mask, resulting in a pseudo-random number between 0 and 31.
This produces the number of slot times to delay,
where a slot is 51 microseconds.
.It
Use the value calculated in step 3 to delay before retransmitting
the packet.
The delay is done in a software busy loop.
.El
.Sh DIAGNOSTICS
.Bl -diag
.It ec%d: send error.
After 16 retransmissions using the
exponential backoff algorithm described above, the packet
was dropped.
.Pp
.It ec%d: input error (offset=%d).
The hardware indicated an error
in reading a packet off the cable or an illegally sized packet.
The buffer offset value is printed for debugging purposes.
.Pp
.It ec%d: can't handle af%d.
The interface was handed
a message with addresses formatted in an unsuitable address
family; the packet was dropped.
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr inet 4 ,
.Xr netintro 4
.Sh HISTORY
The
.Nm
driver appeared in
.Bx 4.2 .
.Sh BUGS
The hardware is not capable of talking to itself.  The software
implements local sending and broadcast by sending such packets to the
loop interface.  This is a kludge.
.Pp
Backoff delays are done in a software busy loop.  This can degrade the
system if the network experiences frequent collisions.
